#include <FK/FK.h>

#include <iostream>
#include <fstream>

vector<string> fk_StrSplit(string argStr, string argToken)
{
	vector<string>		retStrArray;
	string::size_type	curPos = 0, nextPos = 0;

	while(nextPos != string::npos) {
		nextPos = argStr.find(argToken, curPos);
		retStrArray.push_back(argStr.substr(curPos, nextPos-curPos));
		curPos = nextPos+argToken.size();
	}

	return retStrArray;
}

int main(int argc, char *argv[])
{
	Fl_Window		mainWindow(512, 512, "FK TEST");
	fk_Model		camera, blockModel, lightModel;
	fk_Light		light;
	fk_Block		block(50.0, 70.0, 40.0);
	fk_Scene		scene;
	fk_Window		window(0, 0, 512, 512);

	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// ̂̐ݒ
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);

	// effBXvCXgɓo^
	scene.entryCamera(&camera);
	scene.entryModel(&blockModel);
	scene.entryModel(&lightModel);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 0.0, 1000.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	mainWindow.show();
	window.show();

	//////////////////////////////////////////////////////////////

	fk_Vector	vec, dir;

	ofstream	out_file("output_test.txt");

	if(out_file.is_open() == false) {
		fl_alert("t@C݂Ɏs");
	} else {
		out_file << "OUTPUT\tTEST\t00" << endl;

		out_file << vec.x << "," << vec.y << "," << vec.z << endl;
		out_file << dir.x << "," << dir.y << "," << dir.z << endl;

		out_file << "[FINISH]" << endl;

		out_file.close();
	}

	////////////////////////////////////////////////////////////////

	ifstream		in_file("output_test.txt");

	string			lineStr;
	vector<string>	readBuffer, splitArray;
	fk_Vector		rec;
	
	if(in_file.is_open() == false) {
		fl_alert("t@C݂Ɏs");
	} else {
		while(getline(in_file, lineStr)) {
			cout << lineStr << endl;
			// ؂\Ă݂
			splitArray = fk_StrSplit(lineStr, ",");

			if(splitArray.size() <= 1) {
				cout << "Not Split" << endl;
			} else {
				cout << "Split Result:" << endl;
				for(int i = 0 ; i < (int)splitArray.size(); i++) {
					cout << splitArray[i] << endl;
				}
				rec.x = atof(splitArray[0].c_str());
				rec.y = atof(splitArray[1].c_str());
				rec.z = atof(splitArray[2].c_str());
			}

			readBuffer.push_back(lineStr);
		}

		in_file.close();
	}




	while(true) {

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(window.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		// ̂ Y Sɉ]
		blockModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI/100.0);

	}

	return 0;
}
